module Rampart
  class Proxy
    def initialize(strategy_manager, session, user_store)
      @strategy_manager = strategy_manager
      @session = session
      @user_store = user_store
    end

    def authenticate!(*names)
      event = @strategy_manager.authenticate!(*names)
      if event.success?
        set_user(event.user)
        event.user
      else
        throw(:rampart, event.to_truple)
      end
    end

    def authenticate(*names)
      event = @strategy_manager.authenticate!(*names)
      if event.success?
        set_user(event.user)
        event.user
      else
        nil
      end
    end

    def logout
      @session.delete
    end

    def user_id
      @session.fetch
    end

    def set_user(user)
      @user_store.store(user)
    end
  end
end