require "rampart/events/success_event"
require "rampart/events/fail_event"
require "rampart/events/redirect_event"
require "rampart/events/pass_event"

module Rampart
  module Strategy
    def authenticate!(req)
      fail!
    end

    def valid?(req)
      true
    end

    private

    def success!(*args)
      SuccessEvent.new(*args)
    end

    def fail!(*args)
      FailEvent.new(*args)
    end

    def redirect!(*args)
      RedirectEvent.new(*args)
    end

    def pass(*args)
      PassEvent.new(*args)
    end
  end
end